#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

const char stage_table[STAGE_COUNT][(FIELD_COLS - 2) * (FIELD_ROWS - 2) + 1/*nul*/] = {
/*** STAGE 1 ***/
"  #######     "
"  # # # ######"
"### #s# #    #"
"# # # ########"
"##### #x     #"
"#   #x########"
"########x#   #"
"#     x# #####"
"######## # # #"
"#    # # # # #"
"#    # @ # ###"
"###### # # #  "
"     #######  ",
/*** STAGE 2 ***/
" #############"
" xxxx#    #  #"
"############ #"
"#   # s #  # #"
"# ######## ###"
"###  # # ### #"
"# # #### # # #"
"# ### #  ### #"
"# # ###### # #"
"###  # #   ###"
"# ########## #"
"#  #    @    #"
"##############",
/*** STAGE 3 ***/
" ###      ### "
"## ## s  ## ##"
"#   ######   #"
"## ##    ## ##"
" ###      ### "
"## ##x  x## ##"
"#   ######   #"
"## ##x  x## ##"
" ###      ### "
"## ##    ## ##"
"#   ##@###   #"
"## ##    ## ##"
" ###      ### ",
/*** STAGE 4 ***/
"########      "
"#x     ###### "
"#######  #  ##"
"      ###### #"
"###### s#  ###"
"#x   ######   "
"#####  #  ####"
"    ######  x#"
"####  #  #####"
"#  ######     "
"###  @  ######"
"  ######    x#"
"       #######",
/*** STAGE 5 ***/
"### ###       "
"#x### #### ###"
"### #### ###x#"
" #   # ### ###"
"### ###s#   # "
"# ### #### ###"
"# # # ## # # #"
"### #### ### #"
" #   # ### ###"
"### ### @   # "
"#x### #### ###"
"### #### ###x#"
"       ### ###",
/*** STAGE 6 ***/
"     ####     "
"  ####  ####  "
"###  #  #  ###"
"# #  #  #  # #"
"# # ##  ## # #"
"# x        x #"
"######  ######"
"#            #"
"###x##s ##x###"
"#   #    #   #"
"### ##  ## ###"
"  ###    ###  "
"    ##@###    ",
/*** STAGE 7 ***/
"###    ###    "
"# ## ### ##   "
"## ### ## ###x"
" ### ## ###   "
" # ## ### ##  "
" ## ###s## ##x"
"  ### ## ###  "
"x## ## ### ## "
"  ## #@# ## # "
"   ### ## ### "
"x### ## ### ##"
"   ## ### ## #"
"    ###    ###",
/*** STAGE 8 ***/
"   ########   "
"   ########   "
"   ##x##x##   "
"##### ## #####"
"##### ## #####"
"## ######## ##"
"## ##s## ## ##"
"## ######## ##"
"##### @# #####"
"##### ## #####"
"   ##x##x##   "
"   ########   "
"   ########   ",
};

/****************************************************************************
 *	
 ****************************************************************************/

const char pattern_table[PATTERN_COUNT][(FIELD_COLS - 2) * (FIELD_ROWS - 2) + 1/*nul*/] = {
/*** STAGE 1 ***/
"  ooooooo     "
"  # # # oooooo"
"ooo # # #    #"
"# # # oooooooo"
"ooooo #      #"
"#   # oooooooo"
"oooooooo #   #"
"#      # ooooo"
"oooooooo # # #"
"#    # # # # #"
"#    # # # ooo"
"oooooo # # #  "
"     ooooooo  ",
/*** STAGE 2 ***/
" ooooooooooooo"
"     #    #  #"
"oooooooooooo #"
"#   #   #  # #"
"# oooooooo ooo"
"ooo  # # ooo #"
"# # oooo # # #"
"# ooo #  ooo #"
"# # oooooo # #"
"ooo  # #   ooo"
"# oooooooooo #"
"#  #    #    #"
"oooooooooooooo",
/*** STAGE 3 ***/
" ooo      ooo "
"oo oo    oo oo"
"#. .oooooo. .#"
"oo.oo    oo.oo"
" ooo      ooo "
"oo.oo    oo.oo"
"#. .oooooo. .#"
"oo.oo    oo.oo"
" ooo      ooo "
"oo.oo    oo.oo"
"#. .oooooo. .#"
"oo oo    oo oo"
" ooo      ooo ",
/*** STAGE 4 ***/
"oooooooo      "
"#     .oooooo "
"ooooooo..# .oo"
".    .oooooo.#"
"oooooo. #..ooo"
"#   .oooooo. ."
"ooooo..#..oooo"
".  .oooooo.  #"
"oooo..#..ooooo"
"# .oooooo.   ."
"ooo. #..oooooo"
"  oooooo.    #"
"       ooooooo",
/*** STAGE 5 ***/
"ooo ooo       "
"# ooo oooo ooo"
"ooo oooo ooo #"
" #   # ooo ooo"
"ooo ooo #   # "
"# ooo oooo ooo"
"# # # oo # # #"
"ooo oooo ooo #"
" #   # ooo ooo"
"ooo ooo #   # "
"# ooo oooo ooo"
"ooo oooo ooo #"
"       ooo ooo",
/*** STAGE 6 ***/
"     oooo     "
"  oooo  oooo  "
"ooo  #  #  ooo"
"# #  #  #  # #"
"# # oo  oo # #"
"#            #"
"oooooo  oooooo"
"#            #"
"ooo oo  oo ooo"
"#   #    #   #"
"ooo oo  oo ooo"
"  ooo    ooo  "
"    oooooo    ",
/*** STAGE 7 ***/
"ooo    ooo    "
"# oo ooo oo   "
"oo ooo oo ooo "
" ooo oo ooo   "
" # oo ooo oo  "
" oo ooo oo oo "
"  ooo oo ooo  "
" oo oo ooo oo "
"  oo ooo oo # "
"   ooo oo ooo "
" ooo oo ooo oo"
"   oo ooo oo #"
"    ooo    ooo",
/*** STAGE 8 ***/
"   oooooooo   "
"   oooooooo   "
"   oo oo oo   "
"ooooo oo ooooo"
"ooooo oo ooooo"
"oo oooooooo oo"
"oo oo oo oo oo"
"oo oooooooo oo"
"ooooo oo ooooo"
"ooooo oo ooooo"
"   oo oo oo   "
"   oooooooo   "
"   oooooooo   ",
/*** STAGE 9 ***/
"  #######     "
"  # #.#.######"
"###.# #.#... #"
"#.#.#.########"
"#####.# .....#"
"#...# ########"
"######## #...#"
"#..... #.#####"
"########.#.#.#"
"#....#.#.#.#.#"
"# ...#.#.#.###"
"######.#.# #  "
"     #######  ",
/*** STAGE10 ***/
" oooooooooooo#"
"     o....o. o"
"#oooooooooo#.o"
"o ..o. .o..o.o"
"o.#oooooo#.ooo"
"ooo..o.o.ooo.o"
"o.o.#oo#.o.o.o"
"o.ooo.o..ooo.o"
"o.o.#oooo#.o.o"
"ooo..o.o...ooo"
"o.#oooooooo#.o"
"o .o....o... o"
"#oooooooooooo#",
/*** STAGE11 ***/
" ###.    .### "
"## ##.  .## ##"
"#. .######. .#"
"##.##....##.##"
".###.    .###."
"##.## .. ##.##"
"#. .######. .#"
"##.## .. ##.##"
".###.    .###."
"##.##....##.##"
"#. .######. .#"
"## ##....## ##"
" ###.    .### ",
/*** STAGE12 ***/
"#oooooo#      "
"o  ....#oooo# "
"#ooooo#..o..##"
"......#oooo#.o"
"#oooo#. o..#o#"
"o  ..#oooo#..."
"#ooo#..o..#oo#"
"....#oooo#.  o"
"#oo#..o..#ooo#"
"o..#oooo#....."
"#o#..o..#oooo#"
"  #oooo#...  o"
"       #ooooo#",
/*** STAGE13 ***/
"### ###       "
"# ###.#### ###"
"###.####.### #"
".#. .#.###.###"
"###.### #. .#."
"#.###.####.###"
"#.#.#.##.#.#.#"
"###.####.###.#"
".#. .#.###.###"
"###.###.#. .#."
"# ###.####.###"
"### ####.### #"
"       ### ###",
/*** STAGE14 ***/
"     #oo#     "
"  #ooo..ooo#  "
"#oo..o..o..oo#"
"o o..o..o..o o"
"o.o.o#..#o.o.o"
"o. ...  ... .o"
"oooooo..oooooo"
"o.....  .....o"
"ooo #o  oo ooo"
"o ..o.  .o.. o"
"#o#.oo..oo.#o#"
"  #oo....oo#  "
"    #oooo#    ",
/*** STAGE15 ***/
"###.  .###    "
"#.## ###.##   "
"##.###.##.### "
".###.##.### . "
" #.##.###.##. "
" ##.### ##.## "
" .###.##.###. "
" ##.##.###.## "
" .##.###.##.# "
" . ###.##.###."
" ###.##.###.##"
"   ##.### ##.#"
"    ###.  .###",
/*** STAGE16 ***/
"   #oooooo#   "
"   oooooooo   "
"   oo oo oo   "
"#oooo.oo.oooo#"
"ooooo.oo.ooooo"
"oo.oooooooo.oo"
"oo.oo oo oo.oo"
"oo.oooooooo.oo"
"ooooo.oo.ooooo"
"#oooo.oo.oooo#"
"   oo oo oo   "
"   oooooooo   "
"   #oooooo#   ",
/*** STAGE17 ***/
"  o#o#o#o     "
"  o o.o.o####o"
"o#o.o o.o... o"
"o.o.o.o#o####o"
"o#o#o.o .....o"
"o...o oo#o###o"
"o###o#oo o...o"
"o..... o.o#o#o"
"o####o#o.o.o.o"
"o....o.o.o.o.o"
"o ...o.o.o.o#o"
"o####o.o.o o  "
"     o#o#o#o  ",
/*** STAGE18 ***/
" ############o"
"     #....#. #"
"o##########o.#"
"# ..#. .#..#.#"
"#.o######o.###"
"###..#.#.###.#"
"#.#.o##o.#.#.#"
"#.###.#..###.#"
"#.#.o####o.#.#"
"###..#.#...###"
"#.o########o.#"
"# .#....#... #"
"o############o",
/*** STAGE19 ***/
" o#o.    .o#o "
"oo oo.  .oo oo"
"o. .o####o. .o"
"oo.oo....oo.oo"
".o#o.    .o#o."
"oo.oo .. oo.oo"
"o. .o####o. .o"
"oo.oo .. oo.oo"
".o#o.    .o#o."
"oo.oo....oo.oo"
"o. .o####o. .o"
"oo oo....oo oo"
" o#o.    .o#o ",
/*** STAGE20 ***/
"o######o      "
"#  ....o####o "
"o#####o..#..oo"
"......o####o.#"
"o####o. #..o#o"
"#  ..o####o..."
"o###o..#..o##o"
"....o####o.  #"
"o##o..#..o###o"
"#..o####o....."
"o#o..#..o####o"
"  o####o...  #"
"       o#####o",
/*** STAGE21 ***/
"o#o o#o       "
"o o#o.oo#o o#o"
"ooo.oooo.o#o o"
".o. .o.ooo.ooo"
"ooo.ooo o. .o."
"o.o#o.oooo.ooo"
"o.o.o.oo.o.o.o"
"ooo.oooo.o#o.o"
".o. .o.ooo.ooo"
"ooo.ooo.o. .o."
"o o#o.oooo.ooo"
"o#o o#oo.o#o o"
"       o#o o#o",
/*** STAGE22 ***/
"     o##o     "
"  o###..###o  "
"o##..#..#..##o"
"# #..#..#..# #"
"#.#.#o..o#.#.#"
"#. ...  ... .#"
"######..######"
"#.....  .....#"
"### o#  ## ###"
"# ..#.  .#.. #"
"o#o.##..##.o#o"
"  o##....##o  "
"    o####o    ",
/*** STAGE23 ***/
"o#o.  .o#o    "
"o.oo o#o.oo   "
"oo.o#o.oo.o## "
".o#o.oo.o#o . "
" o.oo.o#o.oo. "
" oo.o#o oo.o# "
" .o#o.oo.o#o. "
" #o.oo.o#o.oo "
" .oo.o#o.oo.o "
" . o#o.oo.o#o."
" ##o.oo.o#o.oo"
"   oo.o#o oo.o"
"    o#o.  .o#o",
/*** STAGE24 ***/
"   oooooooo   "
"   o#o##o#o   "
"   oo oo oo   "
"ooo#o.oo.o#ooo"
"o#o#o.oo.o#o#o"
"oo.o######o.oo"
"oo.oo oo oo.oo"
"oo.o######o.oo"
"o#o#o.oo.o#o#o"
"ooo#o.oo.o#ooo"
"   oo oo oo   "
"   o#o##o#o   "
"   oooooooo   ",
};

/****************************************************************************
 *	
 ****************************************************************************/

/* p^[̓Goe[u */
const char enemy_table[PATTERN_COUNT][ENEMY_MAX] = {
/*																莞Ԍɏo	*/
{	ENEMY_TYPE_GUITACO,	ENEMY_TYPE_GUITACO,	ENEMY_TYPE_GUITACO,	ENEMY_TYPE_GUITACO,	0,			ENEMY_TYPE_TRIEN	},	// 0
{	ENEMY_TYPE_GUITACO,	ENEMY_TYPE_GUITACO,	ENEMY_TYPE_CYMBOMB,	ENEMY_TYPE_CYMBOMB,	0,			ENEMY_TYPE_PIANHA	},	// 1
{	ENEMY_TYPE_GUITACO,	ENEMY_TYPE_GUITACO,	ENEMY_TYPE_CYMBOMB,	ENEMY_TYPE_TRIEN,	0,			ENEMY_TYPE_TRIEN	},	// 2
{	ENEMY_TYPE_GUITACO,	ENEMY_TYPE_GUITACO,	ENEMY_TYPE_MADPHONE,	ENEMY_TYPE_MADPHONE,	0,			ENEMY_TYPE_PIANHA	},	// 3
{	ENEMY_TYPE_GUITARO,	ENEMY_TYPE_GUITARO,	ENEMY_TYPE_TRIEN,	ENEMY_TYPE_TRIEN,	0,			ENEMY_TYPE_MADPHONE	},	// 4
{	ENEMY_TYPE_CYMBOMB,	ENEMY_TYPE_MADPHONE,	ENEMY_TYPE_TRIEN,	ENEMY_TYPE_TRIEN,	0,			ENEMY_TYPE_PIANHA	},	// 5
{	ENEMY_TYPE_CYMBOMB,	ENEMY_TYPE_CYMBOMB,	ENEMY_TYPE_CYMBOMB,	ENEMY_TYPE_GUITARO,	0,			ENEMY_TYPE_PIANHA	},	// 6
{	ENEMY_TYPE_CYMBOMB,	ENEMY_TYPE_MADPHONE,	ENEMY_TYPE_TRIEN,	ENEMY_TYPE_TRIEN,	0,			ENEMY_TYPE_TRIEN	},	// 7
//
{	ENEMY_TYPE_GUITACO,	ENEMY_TYPE_CYMBOMB,	ENEMY_TYPE_CYMBOMB,	ENEMY_TYPE_CYMBOMB,	ENEMY_TYPE_CYMBOMB,	ENEMY_TYPE_PIANHA	},	// 8
{	ENEMY_TYPE_GUITACO,	ENEMY_TYPE_MADPHONE,	ENEMY_TYPE_MADPHONE,	ENEMY_TYPE_PIANHA,	ENEMY_TYPE_PIANHA,	ENEMY_TYPE_MADPHONE	},	// 9
{	ENEMY_TYPE_GUITACO,	ENEMY_TYPE_GUITACO,	ENEMY_TYPE_GUITACO,	ENEMY_TYPE_GUITARO,	ENEMY_TYPE_GUITARO,	ENEMY_TYPE_PIANHA	},	//10
{	ENEMY_TYPE_CYMBOMB,	ENEMY_TYPE_CYMBOMB,	ENEMY_TYPE_CYMBOMB,	ENEMY_TYPE_TRIEN,	ENEMY_TYPE_TRIEN,	ENEMY_TYPE_TRIEN	},	//11
{	ENEMY_TYPE_GUITACO,	ENEMY_TYPE_GUITARO,	ENEMY_TYPE_CYMBOMB,	ENEMY_TYPE_MADPHONE,	ENEMY_TYPE_TRIEN,	ENEMY_TYPE_PIANHA	},	//12
{	ENEMY_TYPE_GUITARO,	ENEMY_TYPE_GUITARO,	ENEMY_TYPE_CYMBOMB,	ENEMY_TYPE_MADPHONE,	ENEMY_TYPE_TRIEN,	ENEMY_TYPE_PIANHA	},	//13
{	ENEMY_TYPE_CYMBOMB,	ENEMY_TYPE_CYMBOMB,	ENEMY_TYPE_MADPHONE,	ENEMY_TYPE_TRIEN,	ENEMY_TYPE_TRIEN,	ENEMY_TYPE_PIANHA	},	//14
{	ENEMY_TYPE_GUITARO,	ENEMY_TYPE_GUITARO,	ENEMY_TYPE_MADPHONE,	ENEMY_TYPE_MADPHONE,	ENEMY_TYPE_MADPHONE,	ENEMY_TYPE_PIANHA	},	//15
//
{	ENEMY_TYPE_GUITARO,	ENEMY_TYPE_GUITARO,	ENEMY_TYPE_GUITARO,	ENEMY_TYPE_MADPHONE,	ENEMY_TYPE_TRIEN,	ENEMY_TYPE_PIANHA	},	//16
{	ENEMY_TYPE_CYMBOMB,	ENEMY_TYPE_GUITARO,	ENEMY_TYPE_TRIEN,	ENEMY_TYPE_CYMBOMB,	ENEMY_TYPE_MADPHONE,	ENEMY_TYPE_PIANHA	},	//17
{	ENEMY_TYPE_GUITARO,	ENEMY_TYPE_GUITARO,	ENEMY_TYPE_TRIEN,	ENEMY_TYPE_TRIEN,	ENEMY_TYPE_PIANHA,	ENEMY_TYPE_PIANHA	},	//18
{	ENEMY_TYPE_GUITARO,	ENEMY_TYPE_CYMBOMB,	ENEMY_TYPE_TRIEN,	ENEMY_TYPE_TRIEN,	ENEMY_TYPE_TRIEN,	ENEMY_TYPE_PIANHA	},	//19
{	ENEMY_TYPE_GUITARO,	ENEMY_TYPE_GUITARO,	ENEMY_TYPE_GUITARO,	ENEMY_TYPE_GUITARO,	ENEMY_TYPE_GUITARO,	ENEMY_TYPE_PIANHA	},	//20
{	ENEMY_TYPE_CYMBOMB,	ENEMY_TYPE_CYMBOMB,	ENEMY_TYPE_CYMBOMB,	ENEMY_TYPE_CYMBOMB,	ENEMY_TYPE_CYMBOMB,	ENEMY_TYPE_PIANHA	},	//21
{	ENEMY_TYPE_MADPHONE,	ENEMY_TYPE_TRIEN,	ENEMY_TYPE_TRIEN,	ENEMY_TYPE_TRIEN,	ENEMY_TYPE_TRIEN,	ENEMY_TYPE_PIANHA	},	//22
{	ENEMY_TYPE_TRIEN,	ENEMY_TYPE_TRIEN,	ENEMY_TYPE_PIANHA,	ENEMY_TYPE_PIANHA,	ENEMY_TYPE_PIANHA,	ENEMY_TYPE_PIANHA	},	//23
};

/****************************************************************************
 *	
 ****************************************************************************/

/* p^[̓G̉ */
const int weak_time_table[PATTERN_COUNT] = {
SEC(10),	// 0
SEC(10),	// 1
SEC( 9),	// 2
SEC( 9),	// 3
SEC( 8),	// 4
SEC( 8),	// 5
SEC( 7),	// 6
SEC( 7),	// 7
//
SEC( 6),	// 8
SEC( 6),	// 9
SEC( 5),	//10
SEC( 5),	//11
SEC( 4),	//12
SEC( 4),	//13
SEC( 3),	//14
SEC( 3),	//15
//
SEC( 3),	//16
SEC( 3),	//17
SEC( 3),	//18
SEC( 3),	//19
SEC( 3),	//20
SEC( 3),	//21
SEC( 3),	//22
SEC( 3),	//23
};
